/* -*- buffer-read-only: t -*- vi: set ro:
   THIS FILE IS GENERATED AUTOMATICALLY.  PLEASE DO NOT EDIT.
*/
#ifdef HAVE_CONFIG_H
# include <config.h>
#endif
#include <sys/types.h>

static size_t debug_handle;
/* This must be defined before including debug.h */
#define MF_SOURCE_NAME  debug_handle

#include "mailfromd.h"
#include "prog.h"
#include "builtin.h"

#line 1 "dns.bi"
/* This file is part of Mailfromd.             -*- c -*-
   Copyright (C) 2006, 2007, 2008, 2009, 2010 Sergey Poznyakoff

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 3, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>. */

#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <arpa/inet.h>

void
#line 22
bi_primitive_hostname(eval_environ_t env)
#line 22

#line 22 "dns.bi"
{
#line 22
	
#line 22

#line 22

#line 22
char * string;
#line 22
        
#line 22
get_string_arg(env, 0, &string);
#line 22
        
#line 22

#line 22
        adjust_stack(env, 1);
#line 22

#line 22
	if (builtin_module_trace(BUILTIN_IDX_dns))
#line 22
		prog_trace(env, "primitive_hostname %s",string);;
#line 22

{
	char *hbuf;
	mf_status stat;

	stat = resolve_ipstr(string, &hbuf);
		if (!(stat == mf_success))
#line 28
			env_throw_bi(env, mf_status_to_exception(stat), "primitive_hostname", _("cannot resolve IP %s"),string)
#line 31
;
	
	pushs(env, hbuf);
	free(hbuf);
}
}

void
#line 38
bi_primitive_resolve(eval_environ_t env)
#line 38

#line 38 "dns.bi"
{
#line 38
	
#line 38

#line 38
long __bi_argcnt;
#line 38
char * string;
#line 38
        char * domain;
#line 38
        
#line 38
get_string_arg(env, 1, &string);
#line 38
        get_string_arg(env, 2, &domain);
#line 38
        
#line 38
get_numeric_arg(env, 0, &__bi_argcnt);
#line 38
        adjust_stack(env, __bi_argcnt + 1);
#line 38

#line 38
	if (builtin_module_trace(BUILTIN_IDX_dns))
#line 38
		prog_trace(env, "primitive_resolve %s %s",string, ((__bi_argcnt > 1) ? domain : ""));;
#line 38

{
	char *ipstr;
	mf_status stat;
	
	if (((__bi_argcnt > 1) ? domain : "")[0]) {
		stat = resolve_ipstr_domain(string, domain, &ipstr);
			if (!(stat == mf_success))
#line 45
			env_throw_bi(env, mf_status_to_exception(stat), "primitive_resolve", _("cannot resolve %s.%s"),string,domain)
#line 47
;
	} else {
		stat = resolve_hostname(string, &ipstr);
			if (!(stat == mf_success))
#line 50
			env_throw_bi(env, mf_status_to_exception(stat), "primitive_resolve", _("cannot resolve %s"),string)
#line 52
;
	}
	pushs(env, ipstr);
	free(ipstr);
}
}

static int
ipaddr_cmp(const void *a, const void *b)
{
	GACOPYZ_UINT32_T ipa = ntohl(*(GACOPYZ_UINT32_T*)a);
	GACOPYZ_UINT32_T ipb = ntohl(*(GACOPYZ_UINT32_T*)b);
	if (ipa < ipb)
		return -1;
	if (ipa > ipb)
		return 1;
	return 0;
}

void
#line 71
bi_dns_getaddr(eval_environ_t env)
#line 71

#line 71 "dns.bi"
{
#line 71
	
#line 71

#line 71

#line 71
char * string;
#line 71
        
#line 71
get_string_arg(env, 0, &string);
#line 71
        
#line 71

#line 71
        adjust_stack(env, 1);
#line 71

#line 71
	if (builtin_module_trace(BUILTIN_IDX_dns))
#line 71
		prog_trace(env, "dns_getaddr %s",string);;
#line 71

{
	GACOPYZ_UINT32_T ipbuf[64]; /* FIXME: arbitrary limit */
	size_t i, ipcount;
	unsigned long ttl;
	dns_status dnstat;

	dnstat = a_lookup(string, ipbuf, NELEMS(ipbuf), &ipcount,
			  &ttl, NULL, 0);
	switch (dnstat) {
	case dns_success: {
		heap_obstack_begin(env);
		qsort(ipbuf, ipcount, sizeof ipbuf[0], ipaddr_cmp);
		for (i = 0; i < ipcount; i++) {
			struct in_addr addr;
			char *q;
			
			addr.s_addr = ipbuf[i];
			q = inet_ntoa(addr);
			if (i > 0)
				do { char __c = ' '; heap_obstack_grow(env, &__c, 1); } while(0);
 			
#line 92
do {
#line 92
  char *__s = q;
#line 92
  heap_obstack_grow(env, __s, strlen(__s));
#line 92
} while (0);
		}
		do { char __c = 0; heap_obstack_grow(env, &__c, 1); } while(0);
		
#line 95
do {
#line 95
  push(env, (STKVAL) (heap_obstack_finish(env)));
#line 95
  return;
#line 95
} while (0);
	}
	case dns_not_found:
		do {pushs(env, "");
#line 98
return;
#line 98
} while (0);
	default:
			env_throw_bi(env, dns_to_mf_status(dnstat), "dns_getaddr", _("failed to get A record for %s"),string);
#line 102
	}
}
}

static int
hostname_cmp(const void *a, const void *b)
{
	return strcmp(*(const char**) a, *(const char**) b);
}

void
#line 112
bi_dns_getname(eval_environ_t env)
#line 112

#line 112 "dns.bi"
{
#line 112
	
#line 112

#line 112

#line 112
char * ipstr;
#line 112
        
#line 112
get_string_arg(env, 0, &ipstr);
#line 112
        
#line 112

#line 112
        adjust_stack(env, 1);
#line 112

#line 112
	if (builtin_module_trace(BUILTIN_IDX_dns))
#line 112
		prog_trace(env, "dns_getname %s",ipstr);;
#line 112

{
	dns_status dnstat;
	struct in_addr addr;
	unsigned long ttl;
	char *names[64];

		if (!(inet_aton(ipstr, &addr)))
#line 119
			env_throw_bi(env, mfe_invip, "dns_getname", _("invalid IP: %s"),ipstr)
#line 121
;

	dnstat = ptr_lookup(addr, names, NELEMS(names), &ttl, NULL, 0);
	switch (dnstat) {
	case dns_success: {
		size_t i;
		size_t ncount;

		for (ncount = 0; ncount < NELEMS(names) && names[ncount];
		     ncount++);
		
		qsort(names, ncount, sizeof names[0], hostname_cmp);

		heap_obstack_begin(env);
		for (i = 0; i < ncount; i++) {
			if (i > 0)
				do { char __c = ' '; heap_obstack_grow(env, &__c, 1); } while(0);
			
#line 138
do {
#line 138
  char *__s = names[i];
#line 138
  heap_obstack_grow(env, __s, strlen(__s));
#line 138
} while (0);
		}
		do { char __c = 0; heap_obstack_grow(env, &__c, 1); } while(0);

		for (; i < ncount; i++) 
			free(names[i]);

		
#line 145
do {
#line 145
  push(env, (STKVAL) (heap_obstack_finish(env)));
#line 145
  return;
#line 145
} while (0);
	}
	case dns_not_found:
		do {pushs(env, "");
#line 148
return;
#line 148
} while (0);
	default:
			env_throw_bi(env, dns_to_mf_status(dnstat), "dns_getname", _("failed to get PTR record for %s"),ipstr);
#line 152
	}
}
}

void
#line 156
bi_primitive_hasmx(eval_environ_t env)
#line 156

#line 156 "dns.bi"
{
#line 156
	
#line 156

#line 156

#line 156
char * string;
#line 156
        
#line 156
get_string_arg(env, 0, &string);
#line 156
        
#line 156

#line 156
        adjust_stack(env, 1);
#line 156

#line 156
	if (builtin_module_trace(BUILTIN_IDX_dns))
#line 156
		prog_trace(env, "primitive_hasmx %s",string);;
#line 156

{
	mxbuf_t mxbuf;
	mf_status mxstat;

	mxstat = getmx(string, mxbuf);
	
		if (!(mxstat == mf_success || mxstat == mf_not_found))
#line 163
			env_throw_bi(env, mf_status_to_exception(mxstat), "primitive_hasmx", _("cannot get MX records for %s"),string)
#line 166
;

	if (mxstat == mf_success) {
		dns_freemx(mxbuf);
		
#line 170
do {
#line 170
  push(env, (STKVAL) (1));
#line 170
  return;
#line 170
} while (0);
	}
	
#line 172
do {
#line 172
  push(env, (STKVAL) (0));
#line 172
  return;
#line 172
} while (0);
}
}

void
#line 176
bi_getmx(eval_environ_t env)
#line 176

#line 176 "dns.bi"
{
#line 176
	
#line 176

#line 176
long __bi_argcnt;
#line 176
char * domain;
#line 176
        long  no_resolve;
#line 176
        
#line 176
get_string_arg(env, 1, &domain);
#line 176
        get_numeric_arg(env, 2, &no_resolve);
#line 176
        
#line 176
get_numeric_arg(env, 0, &__bi_argcnt);
#line 176
        adjust_stack(env, __bi_argcnt + 1);
#line 176

#line 176
	if (builtin_module_trace(BUILTIN_IDX_dns))
#line 176
		prog_trace(env, "getmx %s %lu",domain, ((__bi_argcnt > 1) ? no_resolve : 0));;
#line 176

{
	mf_status mxstat;

	if (((__bi_argcnt > 1) ? no_resolve : 0)) {
		GACOPYZ_UINT32_T ipbuf[MAXMXCOUNT];
		size_t ipcount;
		
		mxstat = getmxip(domain, ipbuf, &ipcount);
			if (!(mxstat == mf_success || mxstat == mf_not_found))
#line 185
			env_throw_bi(env, mf_status_to_exception(mxstat), "getmx", _("cannot get MX records for %s"),domain)
#line 187
;
		if (mxstat == mf_not_found)
			do {pushs(env, "");
#line 189
return;
#line 189
} while (0);
		else {
			int i;
			
			heap_obstack_begin(env);
			for (i = 0; i < ipcount; i++) {
				struct in_addr s;
				s.s_addr = htonl(ipbuf[i]);
				
				if (i > 0)
					do { char __c = ' '; heap_obstack_grow(env, &__c, 1); } while(0);
				
#line 200
do {
#line 200
  char *__s = inet_ntoa(s);
#line 200
  heap_obstack_grow(env, __s, strlen(__s));
#line 200
} while (0);
			}
			do { char __c = 0; heap_obstack_grow(env, &__c, 1); } while(0);
			
#line 203
do {
#line 203
  push(env, (STKVAL) (heap_obstack_finish(env)));
#line 203
  return;
#line 203
} while (0);
		}
	} else {
		mxbuf_t mxbuf;
		
		mxstat = getmx(domain, mxbuf);
		if (mxstat == mf_not_found)
			do {pushs(env, "");
#line 210
return;
#line 210
} while (0);
		else {
			int i;
		
			heap_obstack_begin(env);
			for (i = 0; i < MAXMXCOUNT && mxbuf[i]; i++) {
				if (i > 0)
					do { char __c = ' '; heap_obstack_grow(env, &__c, 1); } while(0);
				
#line 218
do {
#line 218
  char *__s = mxbuf[i];
#line 218
  heap_obstack_grow(env, __s, strlen(__s));
#line 218
} while (0);
			}
			do { char __c = 0; heap_obstack_grow(env, &__c, 1); } while(0);
			dns_freemx(mxbuf);
			
#line 222
do {
#line 222
  push(env, (STKVAL) (heap_obstack_finish(env)));
#line 222
  return;
#line 222
} while (0);
		}
	}
}
}

static int
resolve_host(const char *string, unsigned long *ip)
{
	int rc;
	struct in_addr addr;
	char *ipstr;

	if (inet_aton(string, &addr)) {
		*ip = addr.s_addr;
		return 0;
	}
	
	if (resolve_hostname(string, &ipstr) != mf_success)
		return 1;

	rc = inet_aton(ipstr, &addr);
	free(ipstr);
	if (rc == 0) {
		mu_error(_("INTERNAL ERROR at %s:%d: resolve_hostname returned "
			   "invalid IP address: %s"),
			 __FILE__, __LINE__, ipstr);
		return 1;
	}
	*ip = addr.s_addr;
	return 0;
}

void
#line 255
bi_primitive_ismx(eval_environ_t env)
#line 255

#line 255 "dns.bi"
{
#line 255
	
#line 255

#line 255

#line 255
char * domain;
#line 255
        char * ipstr;
#line 255
        
#line 255
get_string_arg(env, 0, &domain);
#line 255
        get_string_arg(env, 1, &ipstr);
#line 255
        
#line 255

#line 255
        adjust_stack(env, 2);
#line 255

#line 255
	if (builtin_module_trace(BUILTIN_IDX_dns))
#line 255
		prog_trace(env, "primitive_ismx %s %s",domain, ipstr);;
#line 255

{
	GACOPYZ_UINT32_T ipbuf[MAXMXCOUNT];
	size_t ipcount;
	mf_status mxstat;
	unsigned long ip;
	int rc = 0;
	int i;
	
		if (!(resolve_host(ipstr, &ip) == 0))
#line 264
			env_throw_bi(env, mfe_noresolve, "primitive_ismx", _("cannot resolve host name %s"),ipstr)
;
	ip = ntohl(ip);
	
	mxstat = getmxip(domain, ipbuf, &ipcount);
	
		if (!(mxstat == mf_success))
#line 270
			env_throw_bi(env, mf_status_to_exception(mxstat), "primitive_ismx", _("cannot get MXs for %s"),domain)
#line 272
;

	for (i = 0; i < ipcount; i++) {
		if (ipbuf[i] == ip) {
			rc = 1;
			break;
		}
	}
	
#line 280
do {
#line 280
  push(env, (STKVAL) (rc));
#line 280
  return;
#line 280
} while (0);
}
}

void
#line 284
bi_relayed(eval_environ_t env)
#line 284

#line 284 "dns.bi"
{
#line 284
	
#line 284

#line 284

#line 284
char * s;
#line 284
        
#line 284
get_string_arg(env, 0, &s);
#line 284
        
#line 284

#line 284
        adjust_stack(env, 1);
#line 284

#line 284
	if (builtin_module_trace(BUILTIN_IDX_dns))
#line 284
		prog_trace(env, "relayed %s",s);;
#line 284

{
	
#line 286
do {
#line 286
  push(env, (STKVAL) (relayed_domain_p(s)));
#line 286
  return;
#line 286
} while (0);
}
}

void
#line 290
bi_listens(eval_environ_t env)
#line 290

#line 290 "dns.bi"
{
#line 290
	
#line 290

#line 290
long __bi_argcnt;
#line 290
char * s;
#line 290
        long  port;
#line 290
        
#line 290
get_string_arg(env, 1, &s);
#line 290
        get_numeric_arg(env, 2, &port);
#line 290
        
#line 290
get_numeric_arg(env, 0, &__bi_argcnt);
#line 290
        adjust_stack(env, __bi_argcnt + 1);
#line 290

#line 290
	if (builtin_module_trace(BUILTIN_IDX_dns))
#line 290
		prog_trace(env, "listens %s %lu",s, ((__bi_argcnt > 1) ? port : 0));;
#line 290

{
	
#line 292
do {
#line 292
  push(env, (STKVAL) (listens_on (s,
#line 292
			      ((__bi_argcnt > 1) ? port : 25),
#line 292
			      smtp_timeout_soft[smtp_timeout_connect])
#line 292
		  == mf_success));
#line 292
  return;
#line 292
} while (0);
#line 296
}
}


#line 299
void
#line 299
dns_init_builtin()
#line 299
{
#line 299
        debug_handle = debug_register("bi_dns");
#line 299
	#line 22 "dns.bi"
va_builtin_install_ex("primitive_hostname", bi_primitive_hostname, 0, dtype_string, 1, 0, 0|0, dtype_string);
#line 38 "dns.bi"
va_builtin_install_ex("primitive_resolve", bi_primitive_resolve, 0, dtype_string, 2, 1, 0|0, dtype_string, dtype_string);
#line 71 "dns.bi"
va_builtin_install_ex("dns_getaddr", bi_dns_getaddr, 0, dtype_string, 1, 0, 0|0, dtype_string);
#line 112 "dns.bi"
va_builtin_install_ex("dns_getname", bi_dns_getname, 0, dtype_string, 1, 0, 0|0, dtype_string);
#line 156 "dns.bi"
va_builtin_install_ex("primitive_hasmx", bi_primitive_hasmx, 0, dtype_number, 1, 0, 0|0, dtype_string);
#line 176 "dns.bi"
va_builtin_install_ex("getmx", bi_getmx, 0, dtype_string, 2, 1, 0|0, dtype_string, dtype_number);
#line 255 "dns.bi"
va_builtin_install_ex("primitive_ismx", bi_primitive_ismx, 0, dtype_number, 2, 0, 0|0, dtype_string, dtype_string);
#line 284 "dns.bi"
va_builtin_install_ex("relayed", bi_relayed, 0, dtype_number, 1, 0, 0|0, dtype_string);
#line 290 "dns.bi"
va_builtin_install_ex("listens", bi_listens, 0, dtype_number, 2, 1, 0|0, dtype_string, dtype_number);

#line 299 "dns.bi"
	
#line 299
}
#line 299

#line 627 "../../mfd/builtin/snarf.m4"

#line 627

